/*
 char.c

 KWC -- Key Width Calculator -- char operations

 Copyright (c) 2000 Edward V. POPKOV
 Distributed under GPL, see COPYING for details

 "Edward V. POPKOV" <evpopkov@carry.netnet.lv>

 $Id: char.c,v 0.2 2000/07/20 11:31:06 root Exp root $

 $Log: char.c,v $
 Revision 0.2  2000/07/20 11:31:06  root
 Floating overflow checks

 Revision 0.1  2000/07/15 03:41:07  root
 Moved math to main(), changed coverage calc. and output format

 Revision 0.0  2000/07/09 21:42:22  root
 Initial check-in

*/

#ifndef _CHAR_
#define _CHAR_

#include <kwc.h>

#define KWC_CHAR_CONVBASE	0

int kwc_char_check( const char * )
	__attribute__(( __regparm__( 1 )));
int kwc_char_tol( kwc_arg_t *, const char * )
	__attribute__(( __regparm__( 2 )));

int kwc_char_check( const char * buf )
{
	int r = FALSE;

KWC_PARAM_CHECK( buf != NULL )

	register size_t s;

	s = KWC_EMPTY;
	while ( isxdigit( buf[ s ]) || buf[ s ] == 'x' || buf[ s ] == 'X' )
		s++;

	r = s > KWC_EMPTY && buf[ s ] == KWC_ZEROC;

	if ( ! r )
		kwc_err( "Illegal char detected or empty string" );

KWC_PARAM_ERROR

	return r;

}/* kwc_char_check */

int kwc_char_tol( kwc_arg_t * res, const char * str )
{
	int r = FALSE;

KWC_PARAM_CHECK( res != NULL && str != NULL )

	char * e;

	(* res) = strtol( str, &e, KWC_CHAR_CONVBASE );
	r = (* e) == KWC_ZEROC && errno != ERANGE;

KWC_R_PERROR( r )
KWC_PARAM_ERROR

	return r;

}/* kwc_char_tol */

#endif /*_CHAR_*/

/* End of char.c */
