/*
 kwc.h

 KWC -- Key Width Calculator -- general header

 Copyright (c) 2000 Edward V. POPKOV
 Distributed under GPL, see COPYING for details

 "Edward V. POPKOV" <evpopkov@carry.netnet.lv>

 $Id: kwc.h,v 0.2 2000/07/20 11:31:06 root Exp root $

 $Log: kwc.h,v $
 Revision 0.2  2000/07/20 11:31:06  root
 Floating overflow checks

 Revision 0.1  2000/07/15 03:41:07  root
 Moved math to main(), changed coverage calc. and output format

 Revision 0.0  2000/07/09 21:42:22  root
 Initial check-in

*/

#ifndef _KWC_H_
#define _KWC_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /*HAVE_CONFIG_H*/

#if STDC_HEADERS
#include <stdlib.h>
#endif /*STDC_HEADERS*/
#if HAVE_CTYPE_H
#include <ctype.h>
#endif /*HAVE_CTYPE_H*/
#if HAVE_ERRNO_H
#include <errno.h>
#endif /*HAVE_ERRNO_H*/
#if HAVE_MATH_H
#include <math.h>
#endif /*HAVE_MATH_H*/
#if HAVE_STDIO_H
#include <stdio.h>
#endif /*HAVE_STDIO_H*/
#if HAVE_UNISTD_H
#include <unistd.h>
#endif /*HAVE_UNISTD_H*/
#if HAVE_VALUES_H
#include <values.h>
#else
#ifndef BITSPERBYTE
#define BITSPERBYTE	8
#endif /*BITSPERBYTE*/
#ifndef CHARBITS
#define CHARBITS	( sizeof( char ) * BITSPERBYTE )
#endif /*CHARBITS*/
#ifndef LONGBITS
#define LONGBITS	( sizeof( long ) * BITSPERBYTE )
#endif /*LONGBITS*/
#endif /*HAVE_VALUES_H*/

#ifndef FALSE
#define FALSE	0
#endif /*FALSE*/

#ifndef TRUE
#define TRUE	1
#endif /*TRUE*/

typedef long int kwc_arg_t;
typedef double kwc_res_t;

#define KWC_ERROR	-1
#define KWC_EMPTY	0
#define KWC_BASE	0
#define KWC_ZEROC	((char) '\0')

#define kwc_err( e )	fprintf( stderr, "KWC %s(): %s.\n", __FUNCTION__, ( e ))

#if HAVE_PERROR
#define kwc_perror	perror( __FUNCTION__ )
#else
#define kwc_perror	kwc_err( "system error" )
#endif /*HAVE_PERROR*/

#if KWC_ENABLE_PARAMCHECK
#define KWC_PARAM_CHECK( r )	if (( r )) {
#define KWC_PARAM_ERROR		} else { kwc_err( "param check failed" ); }
#else
#define KWC_PARAM_CHECK( r )
#define KWC_PARAM_ERROR
#endif /*KWC_ENABLE_PARAMCHECK*/

#define KWC_R_PERROR( r )	if ( ! ( r )) kwc_perror;

#ifndef _CHAR_

extern int kwc_char_check( const char * )
	__attribute__(( __regparm__( 1 )));
extern int kwc_char_tol( kwc_arg_t *, const char * )
	__attribute__(( __regparm__( 2 )));

#endif /*_CHAR_*/

#endif /*_KWC_H_*/

/* End of kwc.h */
